//*****************************************************************************
// File: nvc.h
// Description: Nirva c/c++ client interface
// Author: Pierre MARC
// Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Nirva Systems
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments: 
// ***************************************************************************************

// This file defines the nvs server classes.


#ifndef _NVC_H
#define _NVC_H

#ifndef NVSTDCALL
#ifdef WIN32
#define NVSTDCALL __stdcall
#else
#define NVSTDCALL
#endif
#endif

#define NVREQUEST void*

#ifndef LPCSTR
#define LPCSTR const char*
#endif
#ifndef LPSTR
#define LPSTR char*
#endif

// Exported functions
#ifdef __cplusplus
extern "C" {
#endif
// use to free all the resources
// This function, if used, must be the last function used in the library
void NVSTDCALL NvExitLib();

NVREQUEST NVSTDCALL NvOpenRequest(LPCSTR ConnectString);
void NVSTDCALL NvCloseRequest(NVREQUEST Request);
int NVSTDCALL NvCommand(NVREQUEST Request, LPCSTR Command, LPSTR Buffer, int BufferSize, int *DataSize);

#ifdef __cplusplus
}
#endif



#endif //_NVC_H

