// util.h : header file
//

#ifndef _UTIL_H
#define _UTIL_H

#ifdef WIN32
#include <windows.h>
#endif

#include <string>
#include <vector>


#ifndef WIN32
#ifndef HMODULE
#define HMODULE void *
typedef int (*FARPROC)();
#endif
#endif


int CopyFileEx(const char *SourceFile, const char *DestFile, int Offset=0, int BytesToCopy = -1);
int CopyFileEx(FILE *FileSource, FILE *FileDest, int Offset=0, int BytesToCopy = -1);
int AppendFileEx(const char *SourceFile, const char *DestFile, int Offset=0, int BytesToCopy = -1);
int AppendFileEx(FILE *FileSource, FILE *FileDest, int Offset=0, int BytesToCopy = -1);
bool GetTemporaryFile(std::string &FileName, std::string Dir, std::string Extension, std::string Prefix, std::string Suffix);
void RemoveFile(const char *FileName);
int FileExist(const char *FileName);
int DirExist(const char *DirName);
bool DirList(const char *DirName, const char *Root, std::vector<std::string> *List);
bool IsDirEmpty(const char *DirName);
bool FileList(const char *DirName, const char *Root, std::vector<std::string> *List);
bool CreateDir(const char *DirName);
bool RemoveDir(const char *DirName, bool Self = true, const char *FileRoot = "*", const char *SubDirRoot = "*");
bool GetNoCaseRealFileName(std::string& FileName);
int freadline(char *Line, int LineLength, FILE *stream);
char *strstrnocase(const char *string, const char *strCharSet);
int strcmpnocase(const char *string1, const char *string2);
void CleanString(char *String, bool NoSpace = false);
void CleanString(std::string& StringToClean, bool NoSpace = false);
void AddDirSuffix(std::string& DirName);
void AddEndLine(std::string& String);
void RemoveDirSuffix(std::string& DirName);
bool CompareWorkDir(std::string Dir1, std::string Dir2);
void RemoveFirstAndEndBlanks(std::string& String);
void RemoveDoubleQuotes(std::string& String);
void SetDirName(std::string& DirName);
void GetFromProfile(const char *FileName, char *Output, unsigned int size, const char *Section, const char *Entry, const char *Default);
void RemoveFiles(const char *WorkDir, const char *Root);
std::string GetFirstFileDir(const char *DirName, const char *Root);
unsigned int GetAllocatedMemory();
int ExecPrgm(const char *CommandLine, int *RetCode, int TimeOut);
bool ArrangeDate(std::string& DateToArrange);
bool ArrangeHour(std::string& HourToArrange);
#ifndef WIN32
char *strlwr(char *string);	// These very usefull functions unfornatly doesn't exist on unix
char *strupr(char *string);	// So, we do them
#endif
HMODULE MyLoadLibrary(const char *LibraryPath);
void MyFreeLibrary(HMODULE hModule);
FARPROC MyGetLibFunction(HMODULE hModule, const char *FunctionName);
std::string EncodeStringForXML(std::string StringToEncode);
void SetAsciiFile(const char *FileName);

#endif //_UTIL_H
